CON

  _CLKMODE = XTAL1 + PLL16X
  _CLKFREQ = 80_000_000
   
    
  DEBUG_BAUD = 57_600

VAR
  long oneMS     
  long useser           'USB serial connection detected T/F
  BYTE buttons
     
OBJ
  Tpad          : "QS_ButtonScan" 'this loads the Touchpad driver as alias Touch.
' Buttons       : "Touch Buttons"
  Pst           : "Parallax Serial Terminal"

PUB Main
  oneMs := clkfreq / 1000        
  useser := false
  if ina[31] == 1                      ' RX (pin 31) is high if USB is connected
    Pst.Start(DEBUG_BAUD)
    useser := true                     ' Debug serial connection is active    
  waitcnt(clkfreq * 2 + cnt)           ' time to open debug terminal
  
  Tpad.start( @buttons )        ' start touchpad driver

  dira[23..16]~~                                        ' Set the LEDs as outputs
  repeat
    outa[23..16] := Buttons
    if byte[Buttons AND %00000001] == 1          ' hit it? bit 0
      CountCogs
      WaitMS(20)

PUB CountCogs | numcogs
  numcogs := free_cogs
  pst.str(string("Cogs used: "))
  pst.dec(numcogs)
  pst.char(13)
   
PUB free_cogs : free | i, cog[8], jmp_0

  jmp_0 := %010111_0001_1111_000000000_000000000
  repeat while (cog[free] := cognew(@jmp_0, 0)) => 0 
    free++
  if free
    repeat i from 0 to free - 1
      cogstop(cog[i])
  return free

PUB WaitMS(W)                      'wait for W milliseconds
  WaitCNT ((W*oneMS)+cnt)